org.freedesktop.ModemManager1.Modem.Sar: ModemManager Reference Manual

## org.freedesktop.ModemManager1.Modem.Sar org.freedesktop.ModemManager1.Modem.Sar — The ModemManager dynamic SAR interface. |

## Methods

    Enable        (IN  b enable);
    SetPowerLevel (IN  u level);

## Properties

    State       readable   b
    PowerLevel  readable   u

## Description

The SAR interface defines operations and properties for dynamic SAR, so that user applications can control the output power level dynamically.

Using the SAR interface is not trivial, and it requires prior knowledge of the internal SAR mapping table configured in each device.

The SAR mapping table is defined by the manufacturer of the device, and is usually setup to match a specific hardware setup (e.g. a specific laptop or hardware configuration). This table may provide different power levels for different frequency bands and/or antennas.

An example SAR mapping table, where all bands and antennas share the same level, could look like this:

Power Level | LTE B3 | LTE B7 | LTE B20
0 | 26.0 dBm | 26.5 dBm | 27.0 dBm
1 | 26.5 dBm | 27.0 dBm | 27.5 dBm
2 | 27.0 dBm | 27.5 dBm | 28.0 dBm
3 | 27.5 dBm | 28.0 dBm | 28.5 dBm
4 | 28.0 dBm | 28.5 dBm | 28.5 dBm
5 | 28.5 dBm | 28.5 dBm | 28.5 dBm

In this example, the SAR mapping table has 6 different levels (0 to 5), and it's applied exclusively for LTE bands B3, B7 and B20 in all available antennas. None of this information is exposed to the user in the SAR interface, not even the amount of levels available.

## Method Details

### The `Enable()` method

    Enable (IN  b enable);

Enable or disable dynamic SAR.

When enabled, the modem's output power level can be dynamically updated by the host.

When disabled, the modem's output power level is dynamically updated exclusively by the device.

Since: 1.20

`IN b `enable``: | `TRUE` to enable dynamic SAR and `FALSE` to disable it.

### The `SetPowerLevel()` method

    SetPowerLevel (IN  u level);

Set current dynamic SAR power level for all antennas on the device.

Please check with your modem vendor for detailed description on the number of levels and corresponding power output for each level.

The index set here will apply to all antennas on the system.

Since: 1.20

`IN u `level``: | Index of the SAR power level mapping table.

## Property Details

### The "State" property

    State  readable   b

Boolean indicating whether dynamic SAR is currently enabled.

Since: 1.20

### The "PowerLevel" property

    PowerLevel  readable   u

Current index of the SAR power level mapping table that is being used for setting the output power of all antennas on the system.

This value is only applicable when dynamic SAR is enabled.

Since: 1.20